#[cfg(test)]
mod tests {
    use crate::ai::models::Curve;

    #[test]
    fn test_curve_with_100p_resolution() {
        let curve = Curve {
            values: vec![
                0.0, 0.5576673, 0.8903514, 0.9273334, 0.9531896, 0.9687734, 0.9749388, 0.9725392,
                0.9624287, 0.9454607, 0.9224891, 0.8943676, 0.8619498, 0.8260895, 0.7876405,
                0.7474564, 0.7063909, 0.6652978, 0.6282294, 0.6282294, 0.6282294, 0.6282294,
                0.6282294, 0.6282294, 0.6282294, 0.6282294, 0.6282294, 0.6282294, 0.6282294,
                0.6282294, 0.6282294, 0.6282294, 0.6282294, 0.6282294, 0.6282294, 0.6282294,
                0.6282294, 0.6282294, 0.6282294, 0.6282294, 0.6282294, 0.6282294, 0.6282294,
                0.6282294, 0.6282294, 0.6282294, 0.6282294, 0.6282294, 0.6282294, 0.6282294,
                0.6282294, 0.6282294, 0.6282294, 0.6282294, 0.6282294, 0.6282294, 0.6282294,
                0.6282294, 0.6282294, 0.6282294, 0.6282294, 0.6282294, 0.6282294, 0.6282294,
                0.6282294, 0.6282294, 0.6282294, 0.6282294, 0.4969944, 0.4969944, 0.4969944,
                0.4969944, 0.4969944, 0.4969944, 0.4969944, 0.4969944, 0.1472171, 0.09932621,
                0.0649665, 0.04241943, 0.02996694, 0.02589042, 0.02847154, 0.03599191, 0.04673319,
                0.05897704, 0.07100496, 0.08109865, 0.08753973, 0.08860976, 0.08259049, 0.06776339,
                0.04270938, 0.03796571, 0.07321355, 0.1462293, 0.2547892, 0.3966707, 0.5696484,
                0.7714994, 1.0,
            ],
        };

        let mut actual_values = vec![];
        let mut t = -0.05;
        while t <= 1.05 {
            actual_values.push(curve.evaluate(t));
            t += 0.05;
        }
        let _expected_values = vec![
            0.0,
            0.0,
            0.9687734,
            0.9224891,
            0.7474563,
            0.6282294,
            0.6282294,
            0.6282294,
            0.6282294,
            0.6282294,
            0.6282294,
            0.6282294,
            0.6282294,
            0.6282294,
            0.6282294,
            0.4969944,
            0.49699023,
            0.029966867,
            0.058977257,
            0.08259022,
            0.14623123,
            1.0,
        ];

        // assert_that!(equals!(actual_values, expected_values))
    }
}
